Index: LMDZ6/branches/Ocean_skin/libf/dyn3d/leapfrog.F
===================================================================
--- LMDZ6/branches/Ocean_skin/libf/dyn3d/leapfrog.F	(revision 4013)
+++ LMDZ6/branches/Ocean_skin/libf/dyn3d/leapfrog.F	(revision 4368)
@@ -11,5 +11,5 @@
       use IOIPSL
 #endif
-      USE infotrac, ONLY: nqtot,ok_iso_verif
+      USE infotrac, ONLY: nqtot, isoCheck
       USE guide_mod, ONLY : guide_main
       USE write_field, ONLY: writefield
@@ -26,4 +26,5 @@
       USE temps_mod, ONLY: jD_ref,jH_ref,itaufin,day_ini,day_ref,
      &                        start_time,dt
+      USE strings_mod, ONLY: msg
 
       IMPLICIT NONE
@@ -237,7 +238,5 @@
       jH_cur = jH_cur - int(jH_cur)
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 321')
-        endif !if (ok_iso_verif) then
+      call check_isotopes_seq(q,ip1jmp1,'leapfrog 321')
 
 #ifdef CPP_IOIPSL
@@ -271,7 +270,5 @@
 !      CALL filtreg ( finvmaold ,jjp1, llm, -2,2, .TRUE., 1 )
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 400')
-        endif !if (ok_iso_verif) then
+      call check_isotopes_seq(q,ip1jmp1,'leapfrog 400')
 
    2  CONTINUE ! Matsuno backward or leapfrog step begins here
@@ -324,7 +321,5 @@
 
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 589')
-        endif !if (ok_iso_verif) then
+      call check_isotopes_seq(q,ip1jmp1,'leapfrog 589')
 
 c-----------------------------------------------------------------------
@@ -345,8 +340,6 @@
 c   -------------------------------------------------------------
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,
+      call check_isotopes_seq(q,ip1jmp1,
      &           'leapfrog 686: avant caladvtrac')
-        endif !if (ok_iso_verif) then
 
       IF( forward. OR . leapf )  THEN
@@ -376,8 +369,6 @@
 c   ----------------------------------
 
-        if (ok_iso_verif) then
-           write(*,*) 'leapfrog 720' 
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 756')
-        endif !if (ok_iso_verif) then
+       CALL msg('720', modname, isoCheck)
+       call check_isotopes_seq(q,ip1jmp1,'leapfrog 756')
         
        CALL integrd ( nqtot,vcovm1,ucovm1,tetam1,psm1,massem1 ,
@@ -385,8 +376,6 @@
 !     $              finvmaold                                    )
 
-       if (ok_iso_verif) then
-          write(*,*) 'leapfrog 724'
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 762')
-        endif !if (ok_iso_verif) then
+       CALL msg('724', modname, isoCheck)
+       call check_isotopes_seq(q,ip1jmp1,'leapfrog 762')
 
 c .P.Le Van (26/04/94  ajout de  finvpold dans l'appel d'integrd)
@@ -451,5 +440,5 @@
 c+jld
 
-c  Diagnostique de conservation de l'énergie : initialisation
+c  Diagnostique de conservation de l'energie : initialisation
          IF (ip_ebil_dyn.ge.1 ) THEN 
           ztit='bil dyn'
@@ -498,5 +487,5 @@
        
 c
-c  Diagnostique de conservation de l'énergie : difference
+c  Diagnostique de conservation de l'energie : difference
          IF (ip_ebil_dyn.ge.1 ) THEN 
           ztit='bil phys'
@@ -552,7 +541,5 @@
         CALL massdair(p,masse)
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1196')
-        endif !if (ok_iso_verif) then
+        call check_isotopes_seq(q,ip1jmp1,'leapfrog 1196')
 
 c-----------------------------------------------------------------------
@@ -639,7 +626,5 @@
 c   preparation du pas d'integration suivant  ......
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1509')
-        endif !if (ok_iso_verif) then
+      call check_isotopes_seq(q,ip1jmp1,'leapfrog 1509')
 
       IF ( .NOT.purmats ) THEN
@@ -703,7 +688,5 @@
             ENDIF ! of IF((MOD(itau,iperiod).EQ.0).OR.(itau.EQ.itaufin))
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1584')
-        endif !if (ok_iso_verif) then
+            call check_isotopes_seq(q,ip1jmp1,'leapfrog 1584')
 
 c-----------------------------------------------------------------------
@@ -790,7 +773,5 @@
       ELSE ! of IF (.not.purmats)
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1664')
-        endif !if (ok_iso_verif) then
+            call check_isotopes_seq(q,ip1jmp1,'leapfrog 1664')
 
 c       ........................................................
@@ -817,7 +798,5 @@
             ELSE ! of IF(forward) i.e. backward step
  
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1698')
-        endif !if (ok_iso_verif) then  
+              call check_isotopes_seq(q,ip1jmp1,'leapfrog 1698')
 
               IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin) THEN
Index: LMDZ6/branches/Ocean_skin/libf/dyn3d/qminimum.F
===================================================================
--- LMDZ6/branches/Ocean_skin/libf/dyn3d/qminimum.F	(revision 4013)
+++ LMDZ6/branches/Ocean_skin/libf/dyn3d/qminimum.F	(revision 4368)
@@ -4,5 +4,7 @@
       SUBROUTINE qminimum( q,nqtot,deltap )
 
-      USE infotrac, ONLY: ok_isotopes,ntraciso,iqiso,ok_iso_verif
+      USE infotrac, ONLY: niso, ntiso,iqIsoPha, tracers
+      USE strings_mod, ONLY: strIdx
+      USE readTracFiles_mod, ONLY: addPhase
       IMPLICIT none
 c
@@ -16,10 +18,8 @@
       REAL q(ip1jmp1,llm,nqtot), deltap(ip1jmp1,llm)
 c
-      INTEGER iq_vap, iq_liq
-      PARAMETER ( iq_vap = 1 ) ! indice pour l'eau vapeur
-      PARAMETER ( iq_liq = 2 ) ! indice pour l'eau liquide
-      REAL seuil_vap, seuil_liq
-      PARAMETER ( seuil_vap = 1.0e-10 ) ! seuil pour l'eau vapeur
-      PARAMETER ( seuil_liq = 1.0e-11 ) ! seuil pour l'eau liquide
+      LOGICAL, SAVE :: first=.TRUE.
+      INTEGER, SAVE :: iq_vap, iq_liq        ! indices pour l'eau vapeur/liquide
+      REAL, PARAMETER :: seuil_vap = 1.0e-10 ! seuil pour l'eau vapeur
+      REAL, PARAMETER :: seuil_liq = 1.0e-11 ! seuil pour l'eau liquide
 c
 c  NB. ....( Il est souhaitable mais non obligatoire que les valeurs des
@@ -43,4 +43,10 @@
       !INTEGER nb_pump
       INTEGER ixt
+
+      IF(first) THEN
+         iq_vap = strIdx(tracers(:)%name, addPhase('H2O', 'g'))
+         iq_liq = strIdx(tracers(:)%name, addPhase('H2O', 'l'))
+         first = .FALSE.
+      END IF
 c
 c Quand l'eau liquide est trop petite (ou negative), on prend
@@ -49,7 +55,5 @@
 c
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'qminimum 52')   
-        endif !if (ok_iso_verif) then     
+      call check_isotopes_seq(q,ip1jmp1,'qminimum 52')   
 
       zx_defau_diag(:,:,:)=0.0
@@ -59,8 +63,6 @@
           if (seuil_liq - q(i,k,iq_liq) .gt. 0.d0 ) then
 
-              if (ok_isotopes) then
-                 zx_defau_diag(i,k,iq_liq)=AMAX1
+              if (niso > 0) zx_defau_diag(i,k,iq_liq)=AMAX1
      :               ( seuil_liq - q(i,k,iq_liq), 0.0 )
-              endif !if (ok_isotopes) then
 
              q(i,k,iq_vap) = q(i,k,iq_vap) + q(i,k,iq_liq) - seuil_liq
@@ -80,7 +82,6 @@
           if ( seuil_vap - q(i,k,iq) .gt. 0.d0 ) then
 
-            if (ok_isotopes) then
-              zx_defau_diag(i,k,iq)=AMAX1( seuil_vap - q(i,k,iq), 0.0 )
-            endif !if (ok_isotopes) then
+            if (niso > 0)
+     &        zx_defau_diag(i,k,iq)=AMAX1( seuil_vap - q(i,k,iq), 0.0 )
 
             q(i,k-1,iq) =  q(i,k-1,iq) - ( seuil_vap - q(i,k,iq) ) *
@@ -110,5 +111,5 @@
 
       !write(*,*) 'qminimum 128'
-      if (ok_isotopes) then
+      if (niso > 0) then
       ! CRisi: traiter de même les traceurs d'eau
       ! Mais il faut les prendre à l'envers pour essayer de conserver la
@@ -130,14 +131,16 @@
           if (zx_defau_diag(i,k,iq_vap).gt.0.0) then             
               ! on ajoute la vapeur en k              
-              do ixt=1,ntraciso
-               q(i,k,iqiso(ixt,iq_vap))=q(i,k,iqiso(ixt,iq_vap))
-     :              +zx_defau_diag(i,k,iq_vap)
-     :              *q(i,k-1,iqiso(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
+              do ixt=1,ntiso
+               q(i,k,iqIsoPha(ixt,iq_vap))=q(i,k,iqIsoPha(ixt,iq_vap))
+     :           +zx_defau_diag(i,k,iq_vap)
+     :           *q(i,k-1,iqIsoPha(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
                 
               ! et on la retranche en k-1
-               q(i,k-1,iqiso(ixt,iq_vap))=q(i,k-1,iqiso(ixt,iq_vap))
+               q(i,k-1,iqIsoPha(ixt,iq_vap))=
+     :            q(i,k-1,iqIsoPha(ixt,iq_vap))
      :              -zx_defau_diag(i,k,iq_vap)
      :              *deltap(i,k)/deltap(i,k-1)
-     :              *q(i,k-1,iqiso(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
+     :              *q(i,k-1,iqIsoPha(ixt,iq_vap))
+     :              /q_follow(i,k-1,iq_vap)
 
               enddo !do ixt=1,niso
@@ -151,7 +154,5 @@
        enddo !do k=2,llm
 
-        if (ok_iso_verif) then     
-           call check_isotopes_seq(q,ip1jmp1,'qminimum 168')
-        endif !if (ok_iso_verif) then
+       call check_isotopes_seq(q,ip1jmp1,'qminimum 168')
         
       
@@ -163,12 +164,12 @@
 
               ! on ajoute eau liquide en k en k              
-              do ixt=1,ntraciso
-               q(i,k,iqiso(ixt,iq_liq))=q(i,k,iqiso(ixt,iq_liq))
+              do ixt=1,ntiso
+               q(i,k,iqIsoPha(ixt,iq_liq))=q(i,k,iqIsoPha(ixt,iq_liq))
      :              +zx_defau_diag(i,k,iq_liq)
-     :              *q(i,k,iqiso(ixt,iq_vap))/q_follow(i,k,iq_vap)
+     :              *q(i,k,iqIsoPha(ixt,iq_vap))/q_follow(i,k,iq_vap)
               ! et on la retranche à la vapeur en k
-               q(i,k,iqiso(ixt,iq_vap))=q(i,k,iqiso(ixt,iq_vap))
+               q(i,k,iqIsoPha(ixt,iq_vap))=q(i,k,iqIsoPha(ixt,iq_vap))
      :              -zx_defau_diag(i,k,iq_liq)
-     :              *q(i,k,iqiso(ixt,iq_vap))/q_follow(i,k,iq_vap)   
+     :              *q(i,k,iqIsoPha(ixt,iq_vap))/q_follow(i,k,iq_vap)   
               enddo !do ixt=1,niso
               q_follow(i,k,iq_liq)=   q_follow(i,k,iq_liq)
@@ -180,9 +181,7 @@
        enddo !do k=2,llm  
 
-        if (ok_iso_verif) then
-           call check_isotopes_seq(q,ip1jmp1,'qminimum 197')
-        endif !if (ok_iso_verif) then
+       call check_isotopes_seq(q,ip1jmp1,'qminimum 197')
 
-      endif !if (ok_isotopes) then
+      endif !if (niso > 0) then
       !write(*,*) 'qminimum 188'
       
Index: LMDZ6/branches/Ocean_skin/libf/dyn3d/replay3d.F90
===================================================================
--- LMDZ6/branches/Ocean_skin/libf/dyn3d/replay3d.F90	(revision 4368)
+++ LMDZ6/branches/Ocean_skin/libf/dyn3d/replay3d.F90	(revision 4368)
@@ -0,0 +1,195 @@
+!
+! $Id: gcm.F90 3579 2019-10-09 13:11:07Z fairhead $
+!
+!
+!
+PROGRAM replay3d
+
+
+
+USE comvert_mod, only :  preff, pa
+USE inigeomphy_mod, ONLY: inigeomphy
+
+
+  USE control_mod
+  USE temps_mod, ONLY: calend,start_time,annee_ref,day_ref, &
+                     itau_dyn,itau_phy,day_ini,jD_ref,jH_ref,day_end
+  USE comconst_mod, ONLY: cpp, daysec, dtphys, dtvr, g, r, rad
+  USE logic_mod, ONLY: ecripar, iflag_phys, read_start
+
+  USE serre_mod, ONLY : clon,clat,transx,transy,alphax,alphay,pxo,pyo,              &
+        grossismx, grossismy, dzoomx, dzoomy,taux,tauy
+  USE mod_const_mpi, ONLY: comm_lmdz
+
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  ! FH 2008/05/09 On elimine toutes les clefs physiques dans la dynamique
+  ! A nettoyer. On ne veut qu'une ou deux routines d'interface 
+  ! dynamique -> physique pour l'initialisation
+#ifdef CPP_PHYS
+  USE iniphysiq_mod, ONLY: iniphysiq
+#endif
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  IMPLICIT NONE
+
+  !      ......   Version  du 10/01/98    ..........
+
+  !             avec  coordonnees  verticales hybrides 
+  !   avec nouveaux operat. dissipation * ( gradiv2,divgrad2,nxgraro2 )
+
+  !=======================================================================
+  !
+  !   Auteur:  P. Le Van /L. Fairhead/F.Hourdin
+  !   -------
+  !
+  !   Objet:
+  !   ------
+  !
+  !   GCM LMD nouvelle grille
+  !
+  !=======================================================================
+  !
+  !  ... Dans inigeom , nouveaux calculs pour les elongations  cu , cv
+  !      et possibilite d'appeler une fonction f(y)  a derivee tangente
+  !      hyperbolique a la  place de la fonction a derivee sinusoidale.
+  !  ... Possibilite de choisir le schema pour l'advection de
+  !        q  , en modifiant iadv dans traceur.def  (MAF,10/02) .
+  !
+  !      Pour Van-Leer + Vapeur d'eau saturee, iadv(1)=4. (F.Codron,10/99)
+  !      Pour Van-Leer iadv=10
+  !
+  !-----------------------------------------------------------------------
+  !   Declarations:
+  !   -------------
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comdissnew.h"
+  include "comgeom2.h"
+
+  REAL zdtvr
+
+
+  ! variables dynamiques intermediaire pour le transport
+
+  !   variables pour le fichier histoire
+  REAL dtav      ! intervalle de temps elementaire
+
+  REAL time_0
+
+  LOGICAL lafin
+
+  integer :: ntime=10000,it,klon,klev
+
+
+  ! locales pour gestion du temps
+  INTEGER :: an, mois, jour
+  REAL :: heure
+
+  !   Initialisations:
+  !   ----------------
+
+
+  !----------------------------------------------------------------------
+  !  lecture des fichiers gcm.def ou run.def
+  !  ---------------------------------------
+  !
+preff=101325.
+ pa=50000.
+ clon=0.
+ clat=0.
+ taux=3.
+ tauy=3.
+ dzoomx=0.1
+ dzoomy=0.1
+ grossismx=1.
+ grossismx=1.
+ transx=0.
+ transy=0.
+
+  CALL conf_gcm( 99, .TRUE.)
+
+  if (mod(iphysiq, iperiod) /= 0) call abort_gcm("conf_gcm", &
+       "iphysiq must be a multiple of iperiod", 1)
+
+ rad=6400000
+g=9.81
+
+
+
+  !-----------------------------------------------------------------------
+  !   Choix du calendrier
+  !   -------------------
+
+  !      calend = 'earth_365d'
+
+
+  !-----------------------------------------------------------------------
+  !   Lecture de l'etat initial :
+  !   ---------------------------
+
+  !-----------------------------------------------------------------------
+  !   Lecture des parametres de controle pour la simulation :
+  !   -------------------------------------------------------
+  !  on recalcule eventuellement le pas de temps
+
+
+  zdtvr    = daysec/REAL(day_step)
+
+  !
+  ! on remet le calendrier \`a zero si demande
+  !
+     annee_ref = anneeref
+     day_ref = dayref
+     day_ini = dayref
+     itau_dyn = 0
+     itau_phy = 0
+     time_0 = 0.
+
+  mois = 1
+  heure = 0.
+! call ymds2ju(annee_ref, mois, day_ref, heure, jD_ref)
+  jH_ref = jD_ref - int(jD_ref)
+  jD_ref = int(jD_ref)
+
+
+
+     dtvr = zdtvr
+     CALL iniconst
+     print*,'APRES inisconst'
+     CALL inigeom
+
+
+  CALL inigeomphy(iim,jjm,llm, &
+               1, comm_lmdz, &
+               rlatu,rlatv, &
+               rlonu,rlonv, &
+               aire,cu,cv)
+
+CALL suphel
+!open(82,file='dump_param.bin',form='unformatted',status='old')
+
+
+
+     CALL iophys_ini(900.)
+print*,'Rlatu=',rlatu
+klon=2+iim*(jjm-1)
+klev=llm
+
+!---------------------------------------------------------------------
+! Initialisation de la parametrisation
+!---------------------------------------------------------------------
+      call get_ini_module
+
+!---------------------------------------------------------------------
+! Boucle en temps sur l'appel à la parametrisation
+!---------------------------------------------------------------------
+      DO it=1,ntime
+         print*,'Pas de temps ',it,klon,klev
+         call call_param_replay(klon,klev)
+      ENDDO
+
+
+END PROGRAM replay3d
Index: LMDZ6/branches/Ocean_skin/libf/dyn3d/vlsplt.F
===================================================================
--- LMDZ6/branches/Ocean_skin/libf/dyn3d/vlsplt.F	(revision 4013)
+++ LMDZ6/branches/Ocean_skin/libf/dyn3d/vlsplt.F	(revision 4368)
@@ -4,5 +4,5 @@
 
       SUBROUTINE vlsplt(q,pente_max,masse,w,pbaru,pbarv,pdt,iq)
-      USE infotrac, ONLY: nqtot,nqdesc,iqfils
+      USE infotrac, ONLY: nqtot,tracers
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -38,27 +38,16 @@
 c   ---------
 c
-      INTEGER i,ij,l,j,ii
-      INTEGER ijlqmin,iqmin,jqmin,lqmin
-c
-      REAL zm(ip1jmp1,llm,nqtot),newmasse
+      INTEGER ij,l
+c
+      REAL zm(ip1jmp1,llm,nqtot)
       REAL mu(ip1jmp1,llm)
       REAL mv(ip1jm,llm)
       REAL mw(ip1jmp1,llm+1)
-      REAL zq(ip1jmp1,llm,nqtot),zz
-      REAL dqx(ip1jmp1,llm),dqy(ip1jmp1,llm),dqz(ip1jmp1,llm)
-      REAL second,temps0,temps1,temps2,temps3
-      REAL ztemps1,ztemps2,ztemps3
+      REAL zq(ip1jmp1,llm,nqtot)
       REAL zzpbar, zzw
-      LOGICAL testcpu
-      SAVE testcpu
-      SAVE temps1,temps2,temps3
-      INTEGER iminn,imaxx
       INTEGER ifils,iq2 ! CRisi
 
       REAL qmin,qmax
       DATA qmin,qmax/0.,1.e33/
-      DATA testcpu/.false./
-      DATA temps1,temps2,temps3/0.,0.,0./
-
 
         zzpbar = 0.5 * pdt
@@ -83,10 +72,8 @@
       CALL SCOPY(ijp1llm,masse,1,zm(1,1,iq),1)
         
-      if (nqdesc(iq).gt.0) then  
-        do ifils=1,nqdesc(iq)
-          iq2=iqfils(ifils,iq)
-          CALL SCOPY(ijp1llm,q(1,1,iq2),1,zq(1,1,iq2),1)
-        enddo  
-      endif !if (nqfils(iq).gt.0) then
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        CALL SCOPY(ijp1llm,q(1,1,iq2),1,zq(1,1,iq2),1)
+      enddo  
 
 cprint*,'Entree vlx1'
@@ -122,23 +109,21 @@
       ENDDO
       ! CRisi: aussi pour les fils
-      if (nqdesc(iq).gt.0) then
-      do ifils=1,nqdesc(iq)
-        iq2=iqfils(ifils,iq)
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
         DO l=1,llm
-         DO ij=1,ip1jmp1
-           q(ij,l,iq2)=zq(ij,l,iq2)
-         ENDDO
-         DO ij=1,ip1jm+1,iip1
+          DO ij=1,ip1jmp1
+            q(ij,l,iq2)=zq(ij,l,iq2)
+          ENDDO
+          DO ij=1,ip1jm+1,iip1
             q(ij+iim,l,iq2)=q(ij,l,iq2)
-         ENDDO
+          ENDDO
         ENDDO
-      enddo !do ifils=1,nqdesc(iq)    
-      endif ! if (nqdesc(iq).gt.0) then    
+      enddo
 
       RETURN
       END
       RECURSIVE SUBROUTINE vlx(q,pente_max,masse,u_m,iq)
-      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils, ! CRisi
-     &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
+      USE infotrac, ONLY : nqtot,tracers, ! CRisi
+     &                     min_qParent,min_qMass,min_ratio ! MVals et CRisi
 
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -161,7 +146,6 @@
 c   ----------
       REAL masse(ip1jmp1,llm,nqtot),pente_max
-      REAL u_m( ip1jmp1,llm ),pbarv( iip1,jjm,llm)
+      REAL u_m( ip1jmp1,llm )
       REAL q(ip1jmp1,llm,nqtot)
-      REAL w(ip1jmp1,llm)
       INTEGER iq ! CRisi
 c
@@ -173,5 +157,6 @@
 c
       REAL new_m,zu_m,zdum(ip1jmp1,llm)
-      REAL sigu(ip1jmp1),dxq(ip1jmp1,llm),dxqu(ip1jmp1)
+c      REAL sigu(ip1jmp1)
+      REAL dxq(ip1jmp1,llm),dxqu(ip1jmp1)
       REAL zz(ip1jmp1)
       REAL adxqu(ip1jmp1),dxqmax(ip1jmp1,llm)
@@ -182,23 +167,7 @@
       INTEGER ifils,iq2 ! CRisi
 
-      Logical extremum,first,testcpu
-      SAVE first,testcpu
-
-      REAL      SSUM
-      REAL temps0,temps1,temps2,temps3,temps4,temps5,second
-      SAVE temps0,temps1,temps2,temps3,temps4,temps5
-
-      REAL z1,z2,z3
-
-      DATA first,testcpu/.true.,.false./
-
-      IF(first) THEN
-         temps1=0.
-         temps2=0.
-         temps3=0.
-         temps4=0.
-         temps5=0.
-         first=.false.
-      ENDIF
+      Logical first
+      SAVE first
+      DATA first/.true./
 
 c   calcul de la pente a droite et a gauche de la maille
@@ -436,5 +405,5 @@
          ENDDO
       ENDIF  ! n0.gt.0 
-9999    continue
+c9999    continue
 
 
@@ -449,29 +418,27 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vlsplt 326: iq,nqfils(iq)=',iq,nqfils(iq) 
+      !write(*,*) 'vlsplt 326: iq,nqDesc(iq)=',iq,tracers(iq)%nqDescen
       
-      if (nqdesc(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)
-         DO l=1,llm
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        DO l=1,llm
           DO ij=iip2,ip1jm
-           ! On a besoin de q et masse seulement entre iip2 et ip1jm 
-           !masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
-           !Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           !Mvals: veiller a ce qu'on n'ait pas de denominateur nul
-           masseq(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-           if (q(ij,l,iq).gt.qperemin) then
-             Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           else
-             Ratio(ij,l,iq2)=ratiomin
-           endif
+            ! On a besoin de q et masse seulement entre iip2 et ip1jm 
+            !masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
+            !Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            !Mvals: veiller a ce qu'on n'ait pas de denominateur nul
+            masseq(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),min_qMass)
+            if (q(ij,l,iq).gt.min_qParent) then
+              Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            else
+              Ratio(ij,l,iq2)=min_ratio
+            endif
           enddo   
-         enddo
-        enddo !do ifils=1,nqdesc(iq)
-        do ifils=1,nqfils(iq)
-         iq2=iqfils(ifils,iq)
-         call vlx(Ratio,pente_max,masseq,u_mq,iq2)
-        enddo !do ifils=1,nqfils(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+      enddo
+      do ifils=1,tracers(iq)%nqChildren
+        iq2=tracers(iq)%iqDescen(ifils)
+        call vlx(Ratio,pente_max,masseq,u_mq,iq2)
+      enddo
 ! end CRisi
 
@@ -482,5 +449,5 @@
          DO ij=iip2+1,ip1jm
             !MVals: veiller a ce qu'on ait pas de denominateur nul
-            new_m=max(masse(ij,l,iq)+u_m(ij-1,l)-u_m(ij,l),masseqmin)
+            new_m=max(masse(ij,l,iq)+u_m(ij-1,l)-u_m(ij,l),min_qMass)
             q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+
      &      u_mq(ij-1,l)-u_mq(ij,l))
@@ -498,8 +465,7 @@
       ! On calcule q entre iip2+1,ip1jm -> on fait pareil pour ratio 
       ! puis on boucle en longitude
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)  
-         DO l=1,llm
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        DO l=1,llm
           DO ij=iip2+1,ip1jm
             q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
@@ -508,7 +474,6 @@
              q(ij-iim,l,iq2)=q(ij,l,iq2)
           enddo ! DO ij=ijb+iip1-1,ije,iip1
-         enddo !DO l=1,llm
-        enddo !do ifils=1,nqdesc(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo !DO l=1,llm
+      enddo
 
 c     CALL SCOPY((jjm-1)*llm,q(iip1+iip1,1),iip1,q(iip2,1),iip1)
@@ -519,6 +484,6 @@
       END
       RECURSIVE SUBROUTINE vly(q,pente_max,masse,masse_adv_v,iq)
-      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils, ! CRisi
-     &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
+      USE infotrac, ONLY : nqtot,tracers, ! CRisi
+     &                     min_qParent,min_qMass,min_ratio ! MVals et CRisi
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -544,5 +509,5 @@
       REAL masse(ip1jmp1,llm,nqtot),pente_max
       REAL masse_adv_v( ip1jm,llm)
-      REAL q(ip1jmp1,llm,nqtot), dq( ip1jmp1,llm)
+      REAL q(ip1jmp1,llm,nqtot)
       INTEGER iq ! CRisi
 c
@@ -553,14 +518,13 @@
 c
       REAL airej2,airejjm,airescb(iim),airesch(iim)
-      REAL dyq(ip1jmp1,llm),dyqv(ip1jm),zdvm(ip1jmp1,llm)
+      REAL dyq(ip1jmp1,llm),dyqv(ip1jm)
       REAL adyqv(ip1jm),dyqmax(ip1jmp1)
       REAL qbyv(ip1jm,llm)
 
-      REAL qpns,qpsn,appn,apps,dyn1,dys1,dyn2,dys2,newmasse,fn,fs
+      REAL qpns,qpsn,dyn1,dys1,dyn2,dys2,newmasse,fn,fs
+c     REAL appn apps
 c     REAL newq,oldmasse
-      Logical extremum,first,testcpu
-      REAL temps0,temps1,temps2,temps3,temps4,temps5,second
-      SAVE temps0,temps1,temps2,temps3,temps4,temps5
-      SAVE first,testcpu
+      LOGICAL first
+      SAVE first
 
       REAL convpn,convps,convmpn,convmps
@@ -578,6 +542,5 @@
       REAL      SSUM
 
-      DATA first,testcpu/.true.,.false./
-      DATA temps0,temps1,temps2,temps3,temps4,temps5/0.,0.,0.,0.,0.,0./
+      DATA first/.true./
 
       !write(*,*) 'vly 578: entree, iq=',iq
@@ -778,31 +741,29 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vly 689: iq,nqfils(iq)=',iq,nqfils(iq) 
+      !write(*,*) 'vly 689: iq,nqDesc(iq)=',iq,tracers(iq)%nqDescen
    
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)
-         DO l=1,llm
-         DO ij=1,ip1jmp1
-           ! attention, chaque fils doit avoir son masseq, sinon, le 1er
-           ! fils ecrase le masseq de ses freres.
-           !masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
-           !Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)     
-           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           masseq(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-           if (q(ij,l,iq).gt.qperemin) then
-             Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           else
-             Ratio(ij,l,iq2)=ratiomin
-           endif 
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        DO l=1,llm
+          DO ij=1,ip1jmp1
+            ! attention, chaque fils doit avoir son masseq, sinon, le 1er
+            ! fils ecrase le masseq de ses freres.
+            !masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
+            !Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)     
+            !MVals: veiller a ce qu'on n'ait pas de denominateur nul
+            masseq(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),min_qMass)
+            if (q(ij,l,iq).gt.min_qParent) then
+              Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            else
+              Ratio(ij,l,iq2)=min_ratio
+            endif 
           enddo   
-         enddo
-        enddo !do ifils=1,nqdesc(iq)
-
-        do ifils=1,nqfils(iq)
-         iq2=iqfils(ifils,iq)
-         call vly(Ratio,pente_max,masseq,qbyv,iq2)
-        enddo !do ifils=1,nqfils(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+      enddo
+
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        call vly(Ratio,pente_max,masseq,qbyv,iq2)
+      enddo
 
       DO l=1,llm
@@ -872,14 +833,12 @@
   
 ! retablir les fils en rapport de melange par rapport a l'air:
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)  
-         DO l=1,llm
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        DO l=1,llm
           DO ij=1,ip1jmp1
             q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
           enddo
-         enddo
-        enddo !do ifils=1,nqdesc(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+      enddo
 
       !write(*,*) 'vly 853: sortie'
@@ -888,6 +847,6 @@
       END
       RECURSIVE SUBROUTINE vlz(q,pente_max,masse,w,iq)
-      USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils, ! CRisi 
-     &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
+      USE infotrac, ONLY : nqtot,tracers, ! CRisi 
+     &                     min_qParent,min_qMass,min_ratio ! MVals et CRisi
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -917,5 +876,5 @@
 c   ---------
 c
-      INTEGER i,ij,l,j,ii
+      INTEGER ij,l
 c
       REAL wq(ip1jmp1,llm+1),newmasse
@@ -930,10 +889,11 @@
       SAVE testcpu
 
-      REAL temps0,temps1,temps2,temps3,temps4,temps5,second
-      SAVE temps0,temps1,temps2,temps3,temps4,temps5
-      REAL      SSUM
+#ifdef BIDON
+      REAL temps0,temps1,second
+      SAVE temps0,temps1
 
       DATA testcpu/.false./
-      DATA temps0,temps1,temps2,temps3,temps4,temps5/0.,0.,0.,0.,0.,0./
+      DATA temps0,temps1/0.,0./
+#endif
 
 c    On oriente tout dans le sens de la pression c'est a dire dans le
@@ -1009,28 +969,26 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vlsplt 942: iq,nqfils(iq)=',iq,nqfils(iq)
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)
-         DO l=1,llm
+      !write(*,*) 'vlsplt 942: iq,nqChildren(iq)=',iq,nqChildren(iq)
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        DO l=1,llm
           DO ij=1,ip1jmp1
-           !masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
-           !Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)        
-           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-           masseq(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-           if (q(ij,l,iq).gt.qperemin) then
-             Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
-           else
-             Ratio(ij,l,iq2)=ratiomin
-           endif      
+            !masseq(ij,l,iq2)=masse(ij,l,iq)*q(ij,l,iq)
+            !Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)        
+            !MVals: veiller a ce qu'on n'ait pas de denominateur nul
+            masseq(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),min_qMass)
+            if (q(ij,l,iq).gt.min_qParent) then
+              Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
+            else
+              Ratio(ij,l,iq2)=min_ratio
+            endif      
           enddo   
-         enddo
-        enddo !do ifils=1,nqdesc(iq)
+        enddo
+      enddo
         
-        do ifils=1,nqfils(iq)
-         iq2=iqfils(ifils,iq)         
-         call vlz(Ratio,pente_max,masseq,wq,iq2)
-        enddo !do ifils=1,nqfils(iq)
-      endif !if (nqfils(iq).gt.0) then
+      do ifils=1,tracers(iq)%nqChildren
+        iq2=tracers(iq)%iqDescen(ifils)
+        call vlz(Ratio,pente_max,masseq,wq,iq2)
+      enddo
 ! end CRisi  
 
@@ -1045,14 +1003,12 @@
 
 ! retablir les fils en rapport de melange par rapport a l'air:
-      if (nqfils(iq).gt.0) then  
-       do ifils=1,nqdesc(iq)
-         iq2=iqfils(ifils,iq)  
-         DO l=1,llm
+      do ifils=1,tracers(iq)%nqDescen
+        iq2=tracers(iq)%iqDescen(ifils)
+        DO l=1,llm
           DO ij=1,ip1jmp1
             q(ij,l,iq2)=q(ij,l,iq)*Ratio(ij,l,iq2)            
           enddo
-         enddo
-        enddo !do ifils=1,nqdesc(iq)
-      endif !if (nqfils(iq).gt.0) then
+        enddo
+      enddo
       !write(*,*) 'vlsplt 1032'
 
@@ -1099,4 +1055,5 @@
       real zzq(iip1,jjp1,llm)
 
+#ifdef isminmax
       integer imin,jmin,lmin,ijlmin
       integer imax,jmax,lmax,ijlmax
@@ -1104,5 +1061,4 @@
       integer ismin,ismax
 
-#ifdef isminismax
       call scopy (ip1jmp1*llm,zq,1,zzq,1)
 
@@ -1132,5 +1088,5 @@
 #endif
       return
-9999  format(a20,'  q(',i3,',',i2,',',i2,')=',e12.5,e12.5)
+c9999  format(a20,'  q(',i3,',',i2,',',i2,')=',e12.5,e12.5)
       end
 
